-- 微信自动回复消息表
CREATE TABLE `sys_wx_reply_message` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主鍵',
  `keyword` varchar(255) NOT NULL COMMENT '关键字',
  `type` tinyint(1) NOT NULL COMMENT '消息类型（0：文字，1：图片，2：视频，3：图文消息）',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` datetime NOT NULL COMMENT '更新时间',
  `enable_flag` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否生效（0：未生效，1：生效）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='微信自动回复消息表';

-- 微信自动回复消息素材表
CREATE TABLE `sys_wx_reply_message_media` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `media_type` tinyint(1) NOT NULL COMMENT '素材类型（1：文字，2：图片，3：视频）',
  `title` varchar(255) DEFAULT NULL COMMENT '视频的标题',
  `introduction` varchar(255) DEFAULT NULL COMMENT '视频的描述',
  `content` varchar(1024) DEFAULT NULL COMMENT '内容',
  `name` varchar(255) DEFAULT NULL COMMENT '文件名称',
  `url` varchar(512) DEFAULT NULL COMMENT 'url地址',
  `wx_media_id` varchar(128) DEFAULT NULL COMMENT '微信素材id',
  `sort` int(2) NOT NULL COMMENT '排序',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` datetime NOT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='微信自动回复消息素材表';

-- 微信消息和素材关联表
CREATE TABLE `sys_wx_reply_message_relation` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `message_id` int(11) NOT NULL COMMENT '微信消息id',
  `message_media_id` int(11) NOT NULL COMMENT '微信消息素材id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='微信消息和素材关联表';

-- 微信账号相关数据
INSERT INTO `hnqzx`.`sys_social_details` (`type`, `remark`, `app_id`, `app_secret`, `random_key`, `redirect_url`, `create_time`, `update_time`, `del_flag`, `tenant_id`)
VALUES ('WX_SUBSCRIPTION', '微信公众号-服务器配置', 'AJ82mxfViTNbumFXng3Ts4yiUX1GGKTK', 'MDI0ZWFiMTc4N2NhNDE5NWFiMzU2NGZlOTc5MTVhMTI', NULL, NULL, NOW(), NOW(), '0', '1');

INSERT INTO `hnqzx`.`sys_social_details` (`type`, `remark`, `app_id`, `app_secret`, `random_key`, `redirect_url`, `create_time`, `update_time`, `del_flag`, `tenant_id`)
VALUES ('WX_ACCOUNT', '微信账号', 'wx0bea6759cc4da3e6', 'e594f51fbc6fcbed211caa3292b263fd', NULL, NULL, NOW(), NOW(), '0', '1');

-- 微信自动回复后台管理菜单配置
INSERT INTO `hnqzx`.`sys_menu` (`menu_id`, `name`, `permission`, `path`, `parent_id`, `icon`, `sort`, `keep_alive`, `type`, `create_time`, `update_time`, `del_flag`, `tenant_id`) VALUES ('10219', '智能问答', '', '/mp/wxsmartqa/index', '6000', 'icon-wendang', '1000', '0', '0', '2021-04-30 10:27:40', NULL, '0', '1');
INSERT INTO `hnqzx`.`sys_menu` (`menu_id`, `name`, `permission`, `path`, `parent_id`, `icon`, `sort`, `keep_alive`, `type`, `create_time`, `update_time`, `del_flag`, `tenant_id`) VALUES ('10220', '新增回复', 'mp_wxsmartqa_add', NULL, '10219', NULL, '1', '0', '1', '2019-03-29 15:43:54', '2020-03-24 08:58:39', '0', '1');
INSERT INTO `hnqzx`.`sys_menu` (`menu_id`, `name`, `permission`, `path`, `parent_id`, `icon`, `sort`, `keep_alive`, `type`, `create_time`, `update_time`, `del_flag`, `tenant_id`) VALUES ('10221', '编辑回复', 'mp_wxsmartqa_edit', NULL, '10219', NULL, '2', '0', '1', '2019-03-29 15:43:54', '2020-03-24 08:58:39', '0', '1');
INSERT INTO `hnqzx`.`sys_menu` (`menu_id`, `name`, `permission`, `path`, `parent_id`, `icon`, `sort`, `keep_alive`, `type`, `create_time`, `update_time`, `del_flag`, `tenant_id`) VALUES ('10222', '删除回复', 'mp_wxsmartqa_del', NULL, '10219', NULL, '3', '0', '1', '2021-04-30 10:27:40', NULL, '0', '1');

INSERT INTO `hnqzx`.`sys_role_menu` (`role_id`, `menu_id`) VALUES ('1', '10219');
INSERT INTO `hnqzx`.`sys_role_menu` (`role_id`, `menu_id`) VALUES ('1', '10220');
INSERT INTO `hnqzx`.`sys_role_menu` (`role_id`, `menu_id`) VALUES ('1', '10221');
INSERT INTO `hnqzx`.`sys_role_menu` (`role_id`, `menu_id`) VALUES ('1', '10222');
