package com.qunzhixinxi.hnqz.common.taxhelper.common;

/**
 * {@code CommonConstants} 接口用户定义全局变量
 *
 * @author Hengchen.Sun
 * @version 1.0.0
 * @date 2021-02-22
 * @since ver.1.0.0
 */
public interface CommonConstants {

	/**
	 * 登录时间参数格式化格式模板
	 */
	String LOGIN_DATE_TIME_FORMAT_PATTERN = "yyyyMMddHHmmss";

	//~=======================================[ 状态码常量 ]=========================================
	/**
	 * 成功
	 */
	int SUCCESS_CODE = 2000;

	/**
	 * 客户端问题失败
	 */
	int CLIENT_ERROR_CODE = 4000;

	/**
	 * 服务端问题失败
	 */
	int SERVER_ERROR_CODE = 5000;

	/**
	 * E证通上次认证结果（成功）
	 */
	int LAST_STATUS_SUCCESS_CODE = 1;

	/**
	 * E证通上次认证结果（失败）
	 */
	int LAST_STATUS_FAILURE_CODE = 0;

	//~=======================================[ 认证结果信息 ]=========================================

	String NO_RES_MSG = "无";
	String ALREADY_CERT_SUCCESSFUL = "该人员已实名认证成功";

	//~=======================================[ 服务方法名称 ]=========================================

	/**
	 * 操作方法
	 */
	String ADD_MEMBER_METHOD = "税邦云增员方法";
	String H5_TOKEN_METHOD = "税邦云H5TOKEN方法";
	String BINDING_CARD_CODE_METHOD = "税邦云绑卡验证码";
	String ACK_BINDING_CARD_METHOD = "税邦云绑卡确认";
}
