package com.qunzhixinxi.hnqz.common.taxhelper.entity.model;

import com.qunzhixinxi.hnqz.common.taxhelper.config.TaxHelperConfig;
import lombok.Data;
import lombok.Getter;

/**
 * {@code TaxHelperAddMemberModel} 类增员model
 *
 * @author Hengchen.Sun
 * @version 1.0.0
 * @date 2021-02-22
 * @since ver.1.0.0
 */
@Data
public class TaxHelperAddMemberModel extends TaxHelperModel {

	private static final long serialVersionUID = -7620192525029595859L;

	// 企业信用代码
	private String enterpriseCode;

	// 会员名称
	private String name;

	// 人员类型
	private Integer type;

	// 会员证件类型（固定值）：1->身份证
	private final Integer cardType;

	// 身份证号
	private String idCard;

	// 手机号
	private String phone;

	// 邮箱（固定值）
	private final String email;

	// 地址（固定值）
	private final String address;

	// 回调接口
	private String notifyUrl;

	// 支付通道（固定值）：1->银行卡
	private final Integer payChannel;

	public TaxHelperAddMemberModel(TaxHelperConfig taxHelperConfig) {
		this.appId = taxHelperConfig.getAppId();
		this.appSecrete = taxHelperConfig.getAppSecrete();
		this.queryUrl = taxHelperConfig.getQueryUrl();
		// 身份证
		this.cardType = 1;
		this.email = "taxhelper@yaoyi.net";
		this.address = "北京";
		// 银行卡
		this.payChannel = 1;
	}

}
