package com.qunzhixinxi.hnqz.common.taxhelper.entity.request;

import com.qunzhixinxi.hnqz.common.taxhelper.entity.model.EncryptLoginInfo;
import com.qunzhixinxi.hnqz.common.taxhelper.entity.model.TaxHelperLoginModel;
import lombok.Data;

/**
 * {@code TaxHelperLoginRequest} 登录请求
 *
 * @author Hengchen.Sun
 * @version 1.0.0
 * @date 2021-02-18
 * @since ver.1.0.0
 */
@Data
public class TaxHelperLoginRequest extends TaxHelperRequest {

	// 登录请求地址
	private static final String PATH = "/lgsby/api/loginInterface";

	// 加密信息
	private EncryptLoginInfo encryptLoginInfo;

	public TaxHelperLoginRequest(TaxHelperLoginModel bizModel) {
		this.bizModel = bizModel;
		this.queryUrl = String.format("%s%s", bizModel.getQueryUrl(), PATH);
	}
}
