package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * {@code SysDeptEncryptor} 主体加密器
 *
 * @author Hengchen.Sun
 * @version 1.0.0
 * @date 2021-04-06
 * @since ver.1.0.0
 */
@Data
@ApiModel(value = "主体加密器")
@EqualsAndHashCode(callSuper = true)
@TableName(value = "sys_dept_encryptor")
public class SysDeptEncryptor extends Model<SysDeptEncryptor> {

	private static final long serialVersionUID = 5987850002569556402L;

	private Integer id;

	/**
	 * 主体id
	 */
	private Integer deptId;

	/**
	 * 服务器公钥
	 */
	private String serPublicKey;

	/**
	 * 服务器私钥
	 */
	private String serPrivateKey;

	/**
	 * 客户端公钥
	 */
	private String cliPublicKey;

	/**
	 * 客户端私钥
	 */
	private String cliPrivateKey;

	/**
	 * 签名字符串
	 */
	private String signature;

	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;

	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;
}
