package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.qunzhixinxi.hnqz.admin.enums.SubjectTypeEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 部门管理
 *
 * @author ryz
 * @date 2021-04-19 16:02:30
 */
@Data
@TableName("sys_dept_sub")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "部门管理")
public class SysDeptSub extends Model<SysDeptSub> {

	private static final long serialVersionUID = -1765712668252192954L;

	@TableId
	@ApiModelProperty(value = "主键")
	private Integer subId;

	@ApiModelProperty(value = "机构ID")
	private Integer deptId;

	@ApiModelProperty(value = "账号id")
	private String appId;

	@ApiModelProperty(value = "账号密钥")
	private String appSecret;

	@ApiModelProperty(value = "非对称加密公钥（人力家）")
	private String rsaPublicKey;

	@ApiModelProperty(value = "请求地址")
	private String queryUrl;

	@ApiModelProperty(value = "结算主体")
	private String subjectName;

	@ApiModelProperty(value = "认证方式0-人力家 1-税邦云")
	private String subjectType;

	@ApiModelProperty(value = "限额")
	private BigDecimal limitAmount;

	@ApiModelProperty(value = "是否有效：0-无效 1-生效")
	private String enableFlag;

	@ApiModelProperty(value = "税邦云用户类型id")
	private String subjectUserType;

	@ApiModelProperty(value = "税邦云用户类型对应的发票类目")
	private String subjectInvoiceCategory;
}
