package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;
import java.util.List;

/**
 * 微信消息自动回复实体
 *
 * @author lixuesong
 * @date 2021年04月28日 15:28
 */
@Data
@TableName("sys_wx_reply_message")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "微信消息自动回复")
public class SysWxReplyMessage extends Model<SysWxReplyMessage> {
	private static final long serialVersionUID = 1L;

	/**
	 * 主键id
	 */
	@TableId
	@ApiModelProperty(value = "主键id")
	private Integer id;

	/**
	 * 关键字
	 */
	@ApiModelProperty(value = "关键字")
	private String keyword;

	/**
	 * 消息类型（0：文字，1：图片，2：视频，3：图文消息）
	 */
	@ApiModelProperty(value = "消息类型（0：文字，1：图片，2：视频，3：图文消息）")
	private Integer type;

	/**
	 * 创建时间
	 */
	@ApiModelProperty(value = "创建时间")
	private LocalDateTime createTime;

	/**
	 * 更新时间
	 */
	@ApiModelProperty(value = "更新时间")
	private LocalDateTime updateTime;

	/**
	 * 是否生效（0：未生效，1：生效）
	 */
	@ApiModelProperty(value = "是否生效（0：未生效，1：生效）")
	private Integer enableFlag;

	/**
	 * 消息素材列表
	 */
	@TableField(exist = false)
	private List<SysWxReplyMessageMedia> mediaList;
}
