package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * 微信自动回复消息素材实体
 *
 * @author lixuesong
 * @date 2021年04月28日 17:36
 */
@Data
@TableName("sys_wx_reply_message_media")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "微信自动回复消息素材")
public class SysWxReplyMessageMedia extends Model<SysWxReplyMessage> {
	private static final long serialVersionUID = 1L;

	/**
	 * 主键id
	 */
	@TableId
	@ApiModelProperty(value = "主键id")
	private Integer id;

	/**
	 * 素材类型（0：文字，1：图片，2：视频）
	 */
	@ApiModelProperty(value = "素材类型（0：文字，1：图片，2：视频）")
	private Integer mediaType;

	/**
	 * 视频的标题
	 */
	@ApiModelProperty(value = "视频的标题")
	private String title;

	/**
	 * 视频的描述
	 */
	@ApiModelProperty(value = "视频的描述")
	private String introduction;

	/**
	 * 内容
	 */
	@ApiModelProperty(value = "内容")
	private String content;

	/**
	 * 文件名称如abc.jpg、abc.mp4
	 */
	@ApiModelProperty(value = "文件名称如abc.jpg、abc.mp4")
	private String name;

	/**
	 * 图片或视频的url地址
	 */
	@ApiModelProperty(value = "图片或视频的url地址")
	private String url;

	/**
	 * 微信素材id
	 */
	@ApiModelProperty(value = "微信素材id")
	private String wxMediaId;

	/**
	 * 排序
	 */
	@ApiModelProperty(value = "排序")
	private Integer sort;

	/**
	 * 创建时间
	 */
	@ApiModelProperty(value = "创建时间")
	private LocalDateTime createTime;

	/**
	 * 更新时间
	 */
	@ApiModelProperty(value = "更新时间")
	private LocalDateTime updateTime;

}
