/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * 档案-代理商
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Data
@TableName("wm_da_agent")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "档案-代理商")
public class WmDaAgent extends Model<WmDaAgent> {
	private static final long serialVersionUID = 1L;

	/**
	 *
	 */
	@TableId
	@ApiModelProperty(value="")
	private String id;
	/**
	 * 公司名称
	 */
	@ApiModelProperty(value="公司名称")
	private String gsmc;

	/**
	 * 营业执照
	 */
	@ApiModelProperty(value="营业执照")
	private String yyzz;
	/**
	 * 社保缴纳证明
	 */
	@ApiModelProperty(value="社保缴纳证明")
	private String sbjnzm;
	/**
	 * 法人身份证证明-正面
	 */
	@ApiModelProperty(value="法人身份证证明-正面")
	private String frsfzzmZm;
	/**
	 * 法人身份证证明-背面
	 */
	@ApiModelProperty(value="法人身份证证明-背面")
	private String frsfzzmBm;
	/**
	 * 法人身份证证明-手持
	 */
	@ApiModelProperty(value="法人身份证证明-手持")
	private String frsfzzmSc;
	/**
	 * 是否审核
	 */
	@ApiModelProperty(value="是否审核")
	private String isExamine;


	/**
	 * 证件类型
	 */
	@ApiModelProperty(value="证件类型")
	private String zjType;

	/**
	 * 证件号码
	 */
	@ApiModelProperty(value="证件号码")
	private String zjNumber;

	/**
	 * 结算账号
	 */
	@ApiModelProperty(value="结算账号")
	private String jsAccount;

	/**
	 * 关联药企
	 */
	@ApiModelProperty(value="关联药企")
	private String extDrugEnt;
	/**
	 * 组织机构ID
	 */
	@ApiModelProperty(value="组织机构ID")
	private String deptId;

	/**
	 * 是否删除
	 */
	@ApiModelProperty(value="是否删除")
	private String delFlag;
	/**
	 * 是否禁用
	 */
	@ApiModelProperty(value="是否禁用")
	private String enableFlag;
	/**
	 * 所属租户
	 */
	@ApiModelProperty(value="所属租户",hidden=true)
	private Integer tenantId;
	/**
	 * 创建时间
	 */
	@ApiModelProperty(value="创建时间")
	private LocalDateTime createTime;
	/**
	 * 创建人
	 */
	@ApiModelProperty(value="创建人")
	private Integer createUser;
	/**
	 * 更新时间
	 */
	@ApiModelProperty(value="更新时间")
	private LocalDateTime updateTime;
	/**
	 * 更新人
	 */
	@ApiModelProperty(value="更新人")
	private String updateUser;


	private String drugEntId;

	private String temp1;

	private String temp2;
	/**
	 * 派工权限
	 */
	@ApiModelProperty(value="派工权限")
	private String pgqx;
	/**
	 * 企业类型
	 */
	@ApiModelProperty(value="企业类型")
	private String qylx;
	/**
	 * 企业类型
	 */
	@ApiModelProperty(value="管理模式")
	private String management;

	/**
	 * 结算主体类型：0->人力家，1->税邦云
	 */
	@ApiModelProperty(value="结算主体类型")
	private String[] subjectType;

	/**
	 * 部门专用权限限制（0.导出）
	 */
	@ApiModelProperty(value="部门专用权限限制（0.导出）")
	@TableField(exist = false)
	private String[] deptPermissions;

	/**
	 * 对应sys_dept表level字段
	 */
	@TableField(exist = false)
	private Integer deptLevel;
}
