/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * 档案-药企
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Data
@TableName("wm_da_drug_ent")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "档案-药企")
public class WmDaDrugEnt extends Model<WmDaDrugEnt> {
	private static final long serialVersionUID = 1L;

	/**
	 *
	 */
	@TableId
	@ApiModelProperty(value="")
	private String id;
	/**
	 * 企业名称
	 */
	@ApiModelProperty(value="企业名称")
	private String entname;
	/**
	 * 统一社会信用代码
	 */
	@ApiModelProperty(value="统一社会信用代码")
	private String entcode;
	/**
	 *
	 */
	@ApiModelProperty(value="")
	private String temp1;
	/**
	 *
	 */
	@ApiModelProperty(value="")
	private String temp2;
	/**
	 *
	 */
	@ApiModelProperty(value="")
	private String temp3;
	/**
	 *
	 */
	@ApiModelProperty(value="")
	private String temp4;
	/**
	 * 组织机构ID
	 */
	@ApiModelProperty(value="组织机构ID")
	private String deptId;
	/**
	 * 是否删除
	 */
	@ApiModelProperty(value="是否删除")
	private String delFlag;
	/**
	 * 是否禁用
	 */
	@ApiModelProperty(value="是否禁用")
	private String enableFlag;
	/**
	 * 所属租户
	 */
	@ApiModelProperty(value="所属租户",hidden=true)
	private Integer tenantId;
	/**
	 * 创建时间
	 */
	@ApiModelProperty(value="创建时间")
	private LocalDateTime createTime;
	/**
	 * 创建人
	 */
	@ApiModelProperty(value="创建人")
	private Integer createUser;
	/**
	 * 更新时间
	 */
	@ApiModelProperty(value="更新时间")
	private LocalDateTime updateTime;
	/**
	 * 更新人
	 */
	@ApiModelProperty(value="更新人")
	private Integer updateUser;

	@ApiModelProperty(value="派工权限")
	private String pgqx;

	/**
	 * 管理模式
	 */
	@ApiModelProperty(value="管理模式")
	private String management;

	/**
	 * 结算主体类型：0->人力家，1->税邦云
	 */
	@ApiModelProperty(value="结算主体类型")
	private String[] subjectType;

	/**
	 * 部门专用权限限制（0.导出）
	 */
	@ApiModelProperty(value="部门专用权限限制（0.导出）")
	@TableField(exist = false)
	private String[] deptPermissions;

//	private List<String> subList;
}
