package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * GMV数据统计主表
 *
 * @author lixuesong
 * @date 2021年06月08日 15:25
 */
@Data
@TableName("wm_dept_gmv")
@EqualsAndHashCode(callSuper = true)
public class WmDeptGmv extends Model<WmDeptGmv> {

	/**
	 * 主键id
	 */
	@TableId
	private Integer id;

	/**
	 * 部门id
	 */
	private Integer deptId;

	/**
	 * 年份（yyyy）
	 */
	private String year;

	/**
	 * 月份（MM）
	 */
	private String month;

	/**
	 * 按积分值统计的GMV（保存最近一次的统计，单位：积分）
	 */
	private Long gmv1;

	/**
	 * gmv1收益率（保存最近一次的统计，万分之）
	 */
	private Integer gmv1Rate;

	/**
	 * 按结算额统计的GMV（保存最近一次的统计，单位：分）
	 */
	private Long gmv2;

	/**
	 * gmv2收益率（保存最近一次的统计，万分之）
	 */
	private Integer gmv2Rate;

	/**
	 * 人力家服务费费率（保存最近一次的统计，万分之）
	 */
	private Integer renlijiaServiceChargeRate;

	/**
	 * 要易收益（保存最近一次的统计，单位：分）
	 */
	private Long income;

	/**
	 * 修改时间
	 */
	private LocalDateTime updateTime;

}
