/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * 报告审核表
 *
 * @author pigx code generator
 * @date 2020-12-22 17:05:32
 */
@Data
@TableName("wm_report")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "报告审核表")
public class WmReport extends Model<WmReport> {
	private static final long serialVersionUID = 1L;

	/**
	 * 主键id
	 */
	@TableId
	@ApiModelProperty(value="主键id")
	private Integer id;
	/**
	 * 报告单号
	 */
	@ApiModelProperty(value="报告单号")
	private String reportNo;
	/**
	 * 结算药企ID
	 */
	@ApiModelProperty(value="结算药企ID")
	private Integer drugEntId;
	/**
	 * 积分包ID
	 */
	@ApiModelProperty(value="积分包ID")
	private Integer scoreId;
	/**
	 * 申请结算药企ID
	 */
	@ApiModelProperty(value="申请结算药企ID")
	private Integer applyDrugEntId;
	/**
	 * 积分包值
	 */
	@ApiModelProperty(value="积分包值")
	private String packageScore;
	/**
	 * 任务数量
	 */
	@ApiModelProperty(value="任务数量")
	private String taskNumber;
	/**
	 * 合计分值
	 */
	@ApiModelProperty(value="合计分值")
	private String totalScore;
	/**
	 * 报告状态
	 * 1:待提交，2:已提交待审批 3:已审批待结单 4:已结单
	 */
	@ApiModelProperty(value="报告状态")
	private String reportStatus;

	/**
	 * 创建人
	 */
	@ApiModelProperty(value="创建人")
	private String createPeople;
	/**
	 * 创建时间
	 */
	@ApiModelProperty(value="创建时间")
	private LocalDateTime createTime;
	/**
	 * 审核人
	 */
	@ApiModelProperty(value="审核人")
	private String approvalPeople;
	/**
	 * 审核时间
	 */
	@ApiModelProperty(value="审核时间")
	private LocalDateTime approvalTime;
	/**
	 * 更新人
	 */
	@ApiModelProperty(value="更新人")
	private String updatePeople;
	/**
	 * 更新时间
	 */
	@ApiModelProperty(value="更新时间")
	private LocalDateTime updateTime;
	/**
	 * 是否删除
	 * 0:未删除，1:已删除
	 */
	@ApiModelProperty(value="是否删除")
	private String delFlag;
	/**
	 * 备用1
	 */
	@ApiModelProperty(value="备用1")
	private String export1;
	/**
	 * 备用2
	 */
	@ApiModelProperty(value="备用2")
	private String export2;
	/**
	 * 备用3
	 */
	@ApiModelProperty(value="备用3")
	private String export3;

	/**
	 * 积分包名称
	 */
	@TableField(exist = false)
	private String scorePackageName;
}
