/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 积分包状态
 *
 * @author pigx code generator
 * @date 2020-07-17 23:32:01
 */
@Data
@TableName("wm_score_package_status")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "积分包状态")
public class WmScorePackageStatus extends Model<WmScorePackageStatus> {
	private static final long serialVersionUID = 1L;

	/**
	 * id
	 */
	@TableId
	@ApiModelProperty(value = "id")
	private Integer id;

	/**
	 * 用户id
	 */
	@ApiModelProperty(value = "用户id")
	private String userId;

	/**
	 * 积分包id
	 */
	@ApiModelProperty(value = "积分包id")
	private String packageId;

	/**
	 * 积分包状态
	 */
	@ApiModelProperty(value = "领取后的审核状态")
	private String status;


	/**
	 * 组织机构ID
	 */
	@ApiModelProperty(value = "组织机构ID")
	private String deptId;

	/**
	 * 是否删除
	 */
	@ApiModelProperty(value = "是否删除")
	private String delFlag;

	/**
	 * 是否禁用
	 */
	@ApiModelProperty(value = "是否禁用")
	private String enableFlag;

	/**
	 * 所属租户
	 */
	@ApiModelProperty(value = "所属租户", hidden = true)
	private Integer tenantId;

	/**
	 * 创建时间
	 */
	@ApiModelProperty(value = "创建时间")
	private LocalDateTime createTime;

	/**
	 * 创建人
	 */
	@ApiModelProperty(value = "创建人")
	private Integer createUser;

	/**
	 * 更新时间
	 */
	@ApiModelProperty(value = "更新时间")
	private LocalDateTime updateTime;

	/**
	 * 更新人
	 */
	@ApiModelProperty(value = "更新人")
	private Integer updateUser;

	/**
	 * 手机号
	 */
	@TableField(exist = false)
	private String phone;

	/**
	 * 服务地区
	 */
	@TableField(exist = false)
	private String address;

	/**
	 * 个人预计包值
	 */
	@ApiModelProperty(value = "个人预计包值")
	private String userScore;

	/**
	 * 终止方式
	 */
	@ApiModelProperty(value = "终止方式")
	private String enableType;

	/**
	 * 是否可以继续添加任务,0:不可添加任务，1：可以添加任务
	 */
	@ApiModelProperty(value = "是否可以继续添加任务")
	private String taskAddFlag;

	/**
	 * 任务数量
	 */
	@ApiModelProperty(value = "任务数量")
	private Integer taskNum;

	/**
	 * 积分包名称
	 */
	@TableField(exist = false)
	private String scorePackageName;

	/**
	 * 接单人id
	 */
	@TableField(exist = false)
	private String taskUserId;

	/**
	 * 专员名称
	 */
	@TableField(exist = false)
	private String userRealName;
}
