/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.qunzhixinxi.hnqz.admin.enums.DisplayStatusEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 任务类型打分表
 *
 * @author gaoyang
 * @date 2020-07-01 20:20:05
 */
@Data
@TableName("wm_task_type")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "任务类型打分表")
public class WmTaskType extends Model<WmTaskType> {
private static final long serialVersionUID = 1L;

    @TableId
    @ApiModelProperty(value="")
    private String id;
    /**
     * 任务类型名称
     */
    @ApiModelProperty(value="任务类型名称")
    private String taskTypeName;
    /**
     * 任务类型级别
     */
    @ApiModelProperty(value="任务类型级别")
    private String taskTypeLevel;


	/**
	 * 规则类型，1药企 2一级代理商
	 */
	@ApiModelProperty(value="规则状态")
	private String status;

	/**
	 * 药企ID
	 */
	@ApiModelProperty(value="药企ID")
	private String durgentId;

	/**
	 * 药企ID
	 */
	@ApiModelProperty(value="一级代理商ID")
	private String level1Id;

	/**
	 * 药企ID
	 */
	@ApiModelProperty(value="积分分配代理商ID")
	private String taskEntId;

	/**
	 * 完成后可获得分
	 */
	@ApiModelProperty(value="完成后可获得分")
	private Integer score;
    /**
     * 积分范围开始
     */
    @ApiModelProperty(value="积分范围开始")
    private Integer taskScoreStart;
    /**
     * 积分范围结束
     */
    @ApiModelProperty(value="积分范围结束")
    private Integer taskScoreEnd;
    /**
     * 组织机构ID
     */
    @ApiModelProperty(value="组织机构ID")
    private String deptId;
    /**
     * 是否删除
     */
    @ApiModelProperty(value="是否删除")
    private String delFlag;
    /**
     * 是否禁用
     */
    @ApiModelProperty(value="是否禁用")
    private String enableFlag;
    /**
     * 所属租户
     */
    @ApiModelProperty(value="所属租户",hidden=true)
    private Integer tenantId;
    /**
     * 创建时间
     */
    @ApiModelProperty(value="创建时间")
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value="创建人")
    private Integer createUser;
    /**
     * 更新时间
     */
    @ApiModelProperty(value="更新时间")
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value="更新人")
    private Integer updateUser;

	/**
	 * 基础id
	 */
	@ApiModelProperty(value="更新人")
	private String baseId;

	private String realFlag;
	/**
	 * 规则id
	 */
	@ApiModelProperty(value="规则id")
	private String ruleId;

	/**
	 * 父级id
	 */
	@ApiModelProperty(value="父级id")
	private String parentId;
    }
