package com.qunzhixinxi.hnqz.admin.entity.base;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDeptEncryptor;
import lombok.Data;

import java.io.Serializable;

/**
 * {@code BaseEncryptedInfo} 加密信息基类
 *
 * @author Hengchen.Sun
 * @version 1.0.0
 * @date 2021-04-06
 * @since ver.1.0.0
 */
@Data
public abstract class BaseEncryptedInfo implements Serializable {

	private static final long serialVersionUID = -6417318606163854590L;

	/**
	 * 时间戳
	 */
	private Long timestamp;

	/**
	 * 编码
	 */
	private String charset;

	/**
	 * 签名类型
	 */
	private String signType;

	/**
	 * 格式
	 */
	private String format;

	/**
	 * 签名摘要
	 */
	private String digest;

	/**
	 * 加密器
	 */
	@JsonInclude(value = JsonInclude.Include.NON_NULL)
	private SysDeptEncryptor deptEncryptor;

	/**
	 * 请求id
	 */
	@JsonInclude(value = JsonInclude.Include.NON_NULL)
	private Integer inputId;
}
