package com.qunzhixinxi.hnqz.admin.entity.base;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * {@code BaseEntity} 类
 *
 * @author Hengchen.Sun
 * @version 1.0.0
 * @date 2021-06-07
 * @since ver.1.0.0
 */
@Data
public abstract class BaseEntity implements Serializable {

	private static final long serialVersionUID = 5805047109701650249L;

	@ApiModelProperty(value = "创建时间")
	private LocalDateTime createTime;

	@ApiModelProperty(value = "创建人")
	private Integer createUser;

	@ApiModelProperty(value = "更新时间")
	private LocalDateTime updateTime;

	@ApiModelProperty(value = "更新人")
	private Integer updateUser;

	// 更新
	public @interface Update {
	}

	// 创建
	public @interface Create {
	}
}
