package com.qunzhixinxi.hnqz.admin.entity.model.excel;

import com.alibaba.excel.annotation.ExcelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;


/**
 * 证据链excel模型
 * @author Hengchen.Sun
 * @date 2021/06/21
 * @version 1.0.0
 */
@Data
public class CommonTaskExcelModel implements Serializable {

	private static final long serialVersionUID = 4833712322594179851L;
	/**
	 * id
	 */
	@NotBlank(message = "序号不能为空")
	@ExcelProperty(index = 0)
	private String id;

	/**
	 * 用户真实姓名
	 */
	@NotBlank(message = "用户真实姓名不能为空")
	@ExcelProperty(index = 1)
	private String realName;

	/**
	 * 用户名
	 */
	@NotBlank(message = "用户名不能为空")
	@ExcelProperty(index = 2)
	private String username;

	/**
	 * 积分包名称
	 */
	@NotBlank(message = "积分包名称不能为空")
	@ExcelProperty(index = 3)
	private String scorePackageName;

	/**
	 * 工作系统
	 */
	@NotBlank(message = "工作系统不能为空")
	@ExcelProperty(index = 4)
	private String workstation;


	/**
	 * 受试者编号
	 */
	@NotBlank(message = "受试者编号不能为空")
	@ExcelProperty(index = 5)
	private String subjectNum;

	/**
	 * 方式阶段
	 */
	@NotBlank(message = "访视阶段阶段不能为空")
	@ExcelProperty(index = 6)
	private String visitStage;

	/**
	 * 上传时间
	 */
	@NotBlank(message = "上传时间不能为空")
	@ExcelProperty(index = 7)
	private String uploadTime;

	/**
	 * 审核状态
	 */
	@NotBlank(message = "审核状态不能为空")
	@ExcelProperty(index = 8)
	private String auditStatus;

	/**
	 * 审核通过时间
	 */
	@NotBlank(message = "审核通过时间不能为空")
	@ExcelProperty(index = 9)
	private String passingTime;

	/**
	 * 备注
	 */
	@ExcelProperty(index = 10)
	private String comment;

	/**
	 * 发票类目
	 */
	@NotBlank(message = "发票类目不能为空")
	@ExcelProperty(index = 11)
	private String invoiceCategory;

	/**
	 * 金额
	 */
	@NotBlank(message = "金额不能为空，且采用银行家算法，并保留2位小数")
	@ExcelProperty(index = 12)
	private String amount;

}
