/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackageSettleNote;
import com.qunzhixinxi.hnqz.admin.entity.input.SettleNoteStatusOutput;
import com.qunzhixinxi.hnqz.admin.entity.output.WmTaskSettleNoteOutput;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author pigx code generator
 * @date 2021-01-26 15:44:49
 */
@Mapper
public interface WmScorePackageSettleNoteMapper extends BaseMapper<WmScorePackageSettleNote> {

	SettleNoteStatusOutput selectSettleNoteStatus(String packageId);

	IPage<WmTaskSettleNoteOutput> getWmTaskSettleInfoPage(Page page, @Param("query") WmScorePackageSettleNote note);

	/**
	 * 结算包结算列表（分页）
	 *
	 * @param page
	 * @param note
	 * @return
	 */
	IPage<WmTaskSettleNoteOutput> getWmTaskForSettlePage(Page page, @Param("query") WmScorePackageSettleNote note);

	/**
	 * 结算包结算列表
	 *
	 * @param note
	 * @return
	 */
	List<WmTaskSettleNoteOutput> listWmTaskForSettle(@Param("query") WmScorePackageSettleNote note);
}
