package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.entity.WmDaCustomer;
import com.qunzhixinxi.hnqz.common.core.util.R;

import java.io.IOException;
import java.util.List;

/**
 * 统计管理-月度销售报表
 *
 * @author lixuesong
 * @date 2021年06月04日 16:37
 */
public interface WmDaCustomerStatisticsService {

	/**
	 * 查询当月的统计列表（分页）
	 *
	 * @param page
	 * @param queryWrapper
	 * @return
	 */
//	IPage<WmDaCustomer> listCurrentMonthStatisticsPage(Page page, Wrapper<WmDaCustomer> queryWrapper);

	/**
	 * 查询指定月的统计列表（分页）
	 *
	 * @param page
	 * @param daCustomer
	 * @param startMonth
	 * @param endMonth
	 * @return
	 */
	IPage<WmDaCustomer> listMultiMonthStatisticsPage(Page page, WmDaCustomer daCustomer, Integer startMonth, Integer endMonth);

	/**
	 * 查询指定月的统计列表
	 *
	 * @param daCustomer
	 * @param startMonth
	 * @param endMonth
	 * @return
	 */
	List<WmDaCustomer> listMultiMonthStatistics(WmDaCustomer daCustomer, Integer startMonth, Integer endMonth);

	/**
	 * 导出统计数据
	 *
	 * @param customerList
	 * @return
	 */
	R exportMultiMonthStatistics(List<WmDaCustomer> customerList) throws IOException;
}
