/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackageSettleNote;
import com.qunzhixinxi.hnqz.admin.entity.input.SettleNoteStatusOutput;
import com.qunzhixinxi.hnqz.admin.entity.output.WmTaskSettleNoteOutput;
import com.qunzhixinxi.hnqz.common.core.util.R;

import java.util.List;

/**
 * @author pigx code generator
 * @date 2021-01-26 15:44:49
 */
public interface WmScorePackageSettleNoteService extends IService<WmScorePackageSettleNote> {

	IPage<WmTaskSettleNoteOutput> getWmTaskSettleInfoPage(Page page, WmScorePackageSettleNote note);

	/**
	 * 结算包结算列表（分页）
	 *
	 * @param page
	 * @param note
	 * @return
	 */
	IPage<WmTaskSettleNoteOutput> getWmTaskForSettlePage(Page page, WmScorePackageSettleNote note);

	/**
	 * 结算包结算列表
	 *
	 * @param note
	 * @return
	 */
	List<WmTaskSettleNoteOutput> listWmTaskForSettle(WmScorePackageSettleNote note);

	SettleNoteStatusOutput selectSettleNoteStatus(String packageId);

	R getSettleInfo(WmScorePackageSettleNote note);

	R saveSettleInfo(WmScorePackageSettleNote note);

	R subSettleInfo(WmScorePackageSettleNote note);

	R revokeSettle(WmScorePackageSettleNote note);

	R singletSettle(WmScorePackageSettleNote note);

	R batchSettle(WmScorePackageSettleNote note);

	/**
	 * 税邦云 结算回调
	 *
	 * @param streamId
	 * @param izSingle 是否是单一计算
	 * @return
	 */
	R settleNotify(String streamId, Boolean izSingle);
}
