/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackage;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackageStatus;
import com.qunzhixinxi.hnqz.admin.entity.WmTask;
import com.qunzhixinxi.hnqz.admin.entity.input.WmScorePackageApiInput;
import com.qunzhixinxi.hnqz.admin.entity.input.WmScorePackageApiOutput;
import com.qunzhixinxi.hnqz.common.core.util.R;

import java.util.List;
import java.util.Map;

/**
 * 积分包状态
 *
 * @author pigx code generator
 * @date 2020-07-17 23:32:01
 */
public interface WmScorePackageStatusService extends IService<WmScorePackageStatus> {

	R getPage(Page page, WmScorePackageStatus wmScorePackageStatus);
	R approvalStatus(WmScorePackageStatus wmScorePackageStatus);
	R updateZZ(WmScorePackageStatus wmScorePackageStatus);

	List<WmScorePackageStatus> getByPackageId(WmScorePackageStatus wmScorePackageStatus);

	boolean delStatusByPackageId(String packageId);

	IPage<WmScorePackageApiOutput> getReceivedPackageList(Page page, WmScorePackageApiInput input);

	void updatePackageAndStatus(WmTask wmTask, WmScorePackage wmScorePackage, WmScorePackageStatus scorePackageStatus);

	void updateScorePackageStatus(String ScorePackageId);

	IPage<WmScorePackageStatus> getWmScorePackageStatusPage(Page page, WmScorePackageStatus wmScorePackageStatus);

	/**
	 * 获取当前部门已接单人的列表
	 *
	 * @param deptId 部门id
	 * @param packageType1 积分包任务类型1
	 * @param packageType2 积分包任务类型2
	 * @return
	 */
	List<Map<String, String>> getDeptReceiveUserList(String deptId, String packageType1, String packageType2);
}
