package com.qunzhixinxi.hnqz.admin.view.user;


import com.qunzhixinxi.hnqz.admin.api.enums.SignatureStatusEnum;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;

import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * 小程序修改个人信息
 *
 * @author zhangwt
 * @since 1.0
 */
@Data
@ToString
@AllArgsConstructor
@NoArgsConstructor
public class UserUpdateInput {

	/**
	 * 用户ID
	 */
	@NotNull(message = "用户ID不能为空")
	private String userId;
	/**
	 * 身份证号
	 */
	private String idCardNumber;
	/**
	 * 头像
	 */
	private String avatar;
	/**
	 * 真实名字
	 */
	private String realname;
	/**
	 * 签名信息
	 */
	private String userSign;

	/**
	 * 税邦云协议签署,0->未签署，1->已签署
	 */
	private String taxHelperAgreementSignature;

	private List<String> subList;
}
