package com.qunzhixinxi.hnqz.daemon.quartz.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * GMV数据统计每日记录表
 *
 * @author lixuesong
 * @date 2021年06月08日 15:28
 */
@Data
@TableName("wm_dept_gmv_record")
@EqualsAndHashCode(callSuper = true)
public class WmDeptGmvRecord extends Model<WmDeptGmvRecord> {

	/**
	 * 主键id
	 */
	@TableId
	private Integer id;

	/**
	 * GMV数据统计主表id
	 */
	private Integer gmvId;

	/**
	 * 统计日(1-31)
	 */
	private String statisticsDay;

	/**
	 * 按积分值统计的GMV（单位：积分）
	 */
	private Long gmv1;

	/**
	 * gmv1收益率（万分之）
	 */
	private Integer gmv1Rate;

	/**
	 * 按结算额统计的GMV（单位：分）
	 */
	private Long gmv2;

	/**
	 * gmv2收益率（万分之）
	 */
	private Integer gmv2Rate;

	/**
	 * 人力家服务费费率（万分之）
	 */
	private Integer renlijiaServiceChargeRate;

	/**
	 * 要易收益（单位：分）
	 */
	private Long income;
}
