/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.daemon.quartz.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * 账户充值
 *
 * @author zhangwt
 * @date 2021-02-01 18:06:37
 */
@Data
@TableName("wm_settle_account_receive")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "")
public class WmSettleAccountReceive extends Model<WmSettleAccountReceive> {
	private static final long serialVersionUID = 1L;

	/**
	 *
	 */
	@TableId
	@ApiModelProperty(value = "")
	private Integer id;
	/**
	 * 账户名称
	 */
	@ApiModelProperty(value = "")
	private String accountName;
	/**
	 * 账户编号
	 */
	@ApiModelProperty(value = "")
	private String accountNo;
	/**
	 *
	 */
	@ApiModelProperty(value = "")
	private String opType;
	/**
	 * 充值金额
	 */
	@ApiModelProperty(value = "")
	private String amount;
	/**
	 *
	 */
	@ApiModelProperty(value = "")
	private String bankSerialNo;
	/**
	 *
	 */
	@ApiModelProperty(value = "")
	private String explore1;
	/**
	 *
	 */
	@ApiModelProperty(value = "")
	private String explore2;
	/**
	 *
	 */
	@ApiModelProperty(value = "")
	private String explore3;

	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;
}
