package com.qunzhixinxi.hnqz.daemon.quartz.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qunzhixinxi.hnqz.daemon.quartz.entity.WmScorePackageSettleNote;
import com.qunzhixinxi.hnqz.daemon.quartz.mapper.WmScorePackageSettleNoteMapper;
import com.qunzhixinxi.hnqz.daemon.quartz.service.WmScorePackageSettleNoteService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.List;

/**
 * {@code WmScorePackageSettleNoteServiceImpl} 类
 *
 * @author Hengchen.Sun
 * @version 1.0.0
 * @date 2021-06-08
 * @since ver.1.0.0
 */
@Service
@AllArgsConstructor
@Slf4j
public class WmScorePackageSettleNoteServiceImpl extends ServiceImpl<WmScorePackageSettleNoteMapper, WmScorePackageSettleNote> implements WmScorePackageSettleNoteService {

	private WmScorePackageSettleNoteMapper wmScorePackageSettleNoteMapper;

	/**
	 * 计算指定部门对应的结算数据之和
	 *
	 * @param deptId
	 * @param subType
	 * @param startTime
	 * @param endTime
	 * @return
	 */
	@Override
	public List<WmScorePackageSettleNote> listSettleAmountByDeptId(Integer deptId, String subType, LocalDateTime startTime, LocalDateTime endTime) {
		return wmScorePackageSettleNoteMapper.listSettleAmountByDeptId(deptId, subType, startTime, endTime);
	}
}
